<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div v-if="selectedMethod === 'database'" class="database-connection">
        <div class="database-tab-nav">
            <div :class="['database-tab-item', { 'active': activeTab === 'new' }]"
                @click="setActiveTab('new')">Create New Database Connection</div>
            <div :class="['database-tab-item', { 'active': activeTab === 'existing' }]"
                @click="setActiveTab('existing')">Select from existing</div>
        </div>
        <div class="database-tab-area">
            <!-- ==== STEP 2.3.1 - Create new database connection ===-->
            <div :class="['tab-content tab-area-new', { 'active': activeTab === 'new' }]">
                <form id="dataset-step-2-database-connection"
                    @submit.prevent="handleSubmitDatabase">
                    <div class="field field-modal-big-label field-database">
                        <label for="" class="label">Connection Name</label>
                        <input type="text" name="connection-name" id="connection-name"
                            minlength="3" maxlength="30" required  data-error-message="Fill in this field.">
                        <span class="max-characters">
                            <span class="text">Max. 30 characters</span><span
                                class="separator"></span> <button> <i
                                    class="icon-delete"></i></button>
                        </span>
                    </div>
                    <div class="field field-modal-big-label field-database">
                        <label for="" class="label">Connection description</label>
                        <textarea type="text" name="connection-description"
                            id="connection-description" required minlength="3" data-error-message="Fill in this field."></textarea>
                    </div>
                    <div class="modal-box field-database">
                        <div class="modal-box-search">
                            <h3>Type</h3>
                            <div class="search-wrapper">
                                <input type="text" name="type-search" class="input-search">
                            </div>
                        </div>
                        <ul class="modal-box-checkbox-list modal-box-checkbox-list-ball">
                            <li v-for="typeItem in types" :key="typeItem?.id">
                                <input type="radio" :value="typeItem.value"
                                    :id="`type-${typeItem?.id}`" name="database-type"
                                    @change="toggleTypeDatabase" />
                                <label :for="`type-${typeItem?.id}`">{{ typeItem?.name
                                    }}</label>
                            </li>
                        </ul>
                    </div>
                    <div class="modal-input field-database">
                        <label for="port-id">Port ID</label>
                        <input type="text" name="database-port" id="port-id" minlength="3"
                            required data-error-message="Fill in this field." />
                    </div>
                    <div class="modal-input field-database">
                        <label for="host-name">Host Name</label>
                        <input type="text" name="database-host" id="host-name" minlength="3"
                            required data-error-message="Fill in this field." />
                    </div>
                    <div class="modal-input field-database">
                        <label for="database-name">Database Name</label>
                        <input type="text" name="database-database-name" id="database-name"
                            minlength="3" required data-error-message="Fill in this field." />
                    </div>
                    <div class="modal-input field-database" v-if="showSchemaField">
                        <label for="database-schema">Database Schema</label>
                        <input type="text" name="database-schema" id="database-schema"
                            minlength="3" required data-error-message="Fill in this field." />
                    </div>
                    <div class="modal-input field-database" v-if="showKeyspaceField">
                        <label for="database-keyspace">Database Keyspace</label>
                        <input type="text" name="database-keyspace" id="database-keyspace"
                            minlength="3" required data-error-message="Fill in this field." />
                    </div>
                    <div class="modal-input field-database">
                        <label for="database-user">User Name</label>
                        <input type="text" name="database-username" id="database-name"
                            minlength="3" required data-error-message="Fill in this field." />
                    </div>
                    <div class="modal-input field-database">
                        <label for="database-password">Password</label>
                        <input type="password" name="database-password" id="password"
                            minlength="3" required data-error-message="Fill in this field." />
                    </div>
                </form>
            </div>
            <!-- ==== STEP 2.3.2 - Select from existing ===-->
            <div
                :class="['tab-content tab-area-existing', { 'active': activeTab === 'existing' }]">
                <div class="modal-box field-database">
                    <div class="modal-box-search">
                        <h3>Select from previous usage</h3>
                        <div class="search-wrapper">
                            <input type="text" name="type-search" class="input-search">
                        </div>
                    </div>
                    <ul class="modal-box-checkbox-list modal-box-checkbox-list-full">
                        <li v-for="previousConnection in previousConnections"
                            :key="previousConnection?.id">
                            <input type="checkbox"
                                :id="`connection-${previousConnection?.id}`"
                                :checked="selectedConnection === previousConnection?.id"
                                @change="handleCheckboxChange(previousConnection?.id, previousConnection?.name)" />
                            <label :for="`connection-${previousConnection?.id}`">{{
                                previousConnection?.name }}</label>
                        </li>
                        <li>
                            <span>
                                <i class="icon-add add"></i>
                                312
                                <i class="icon-arrow-down arrow"></i>
                            </span>
                        </li>
                    </ul>
                </div>
                <div :class="{ 'show': isConnectionSelected }"
                    class="previous-database-connection">
                    <form action="">
                        <div class="field field-modal-big-label field-database">
                            <label for="" class="label">Connection Name</label>
                            <input type="text" name="connection-name-previous"
                                id="connection-name-previous"
                                :value="selectedConnectionName">
                            <span class="max-characters">
                                <span class="text">Max. 30 characters</span><span
                                    class="separator"></span> <button> <i
                                        class="icon-delete"></i></button>
                            </span>
                        </div>
                        <div class="modal-box field-database">
                            <div class="modal-box-search">
                                <h3>Type</h3>
                                <div class="search-wrapper">
                                    <input type="text" name="type-search"
                                        class="input-search">
                                </div>
                            </div>
                            <ul
                                class="modal-box-checkbox-list modal-box-checkbox-list-ball">
                                <li v-for="typeItem in types" :key="typeItem?.id">
                                    <input type="checkbox"
                                        :id="`type-${typeItem?.id}-previous`" />
                                    <label :for="`type-${typeItem?.id}-previous`">{{
                                        typeItem?.name }}</label>
                                </li>
                            </ul>
                        </div>
                        <div class="modal-input field-database">
                            <label for="port-id">Port ID</label>
                            <input type="text" name="port-id-previous"
                                id="port-id-previous" />
                        </div>
                        <div class="modal-input field-database">
                            <label for="host-name">Host Name</label>
                            <input type="text" name="host-name-previous"
                                id="host-name-previous" />
                        </div>
                        <div class="modal-input field-database">
                            <label for="database-name">Database Name</label>
                            <input type="text" name="database-name-previous"
                                id="database-name-previous" />
                        </div>
                        <div class="modal-input field-database">
                            <label for="database-user">User Name</label>
                            <input type="text" name="database-user-previous"
                                id="database-name-previous" />
                        </div>
                        <div class="modal-input field-database">
                            <label for="database-password">Password</label>
                            <input type="password" name="password-previous"
                                id="password-previous" />
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</template>

<script setup lang="ts">

import { ref  } from 'vue';
import type { platformArray } from '~/interfaces/types';
import { generateUUID, highlightInvalidFields, updateLoadingUI, clearAllValidationErrors } from '~/utils/utils';

// Define the props that the component receives
const props = defineProps({
    selectedMethod: String, // The selected method for data submission (e.g., Bulk, Streaming).
    createdDatasetId: String, // The ID of the dataset that has been created.
    currentStep: Number, // The current step in the process.
    datasetName: String, // The name of the dataset being worked on.
    nextStep: {
        type: Function, // A function to call when moving to the next step.
        required: true, // This prop is required.
    },
    submitDataStreaming: {
        type: Function, // A function to submit data using the streaming method.
        required: true // This prop is required.
    }
});

// Reactive reference to track the active tab in the UI
const activeTab = ref('new');

/**
 * Sets the active tab in the UI to the given value.
 * @param {string} tab The name of the tab to activate.
 */
const setActiveTab = (tab: string) => {
    activeTab.value = tab;
};

// Array of database types available for selection
const types = ref<platformArray[]>([
    {
        id: 1,
        name: 'PostgreSQL',
        value: 'postgres'
    },
    {
        id: 2,
        name: 'Oracle',
        value: 'oracle'
    },
    {
        id: 3,
        name: 'Cassandra',
        value: 'cassandra'
    },
    {
        id: 4,
        name: 'Oracle',
        value: 'oracle'
    }
])

// Array of previous connections for user reference
const previousConnections = ref<platformArray[]>([
    {
        id: 1,
        name: 'Mathematics',
        value: 'mathematics'
    },
    {
        id: 2,
        name: 'Computer Science / Finance',
        value: 'computer science / finance'
    },
    {
        id: 3,
        name: 'Medicine / Health Sciences',
        value: 'medicine / health sciences'
    },
    {
        id: 4,
        name: 'Civil Engineering',
        value: 'civil engineering'
    },
    {
        id: 5,
        name: 'Computer Science / Artificial Intelligence',
        value: 'computer science / artificial intelligence'
    }
])

// Reactive references for UI visibility
const showSchemaField = ref(false);
const showKeyspaceField = ref(false);

/**
 * Handles toggling the visibility of the schema and keyspace fields based on the selected
 * database type.
 *
 * @param {Event} event - The event object that triggered this function.
 */
const toggleTypeDatabase = (event: any) => {
    if (event.target.value === 'cassandra') {
        alert("This method is not implemented yet");
        showKeyspaceField.value = true;

    } else if (event.target.value === 'postgres') {
        showSchemaField.value = true;
    } else {
        alert("This method is not implemented yet");
        showSchemaField.value = false;
        showKeyspaceField.value = false;
    }
}

// Reactive references to track selected connection
const selectedConnection = ref<number | null>(null); // Currently selected connection ID
const selectedConnectionName = ref<string>(''); // Name of the selected connection
const isConnectionSelected = ref<boolean>(false); // Flag to indicate if a connection is selected

/**
 * Handles the change event for the checkboxes representing previous connections.
 * If the user clicks on a previously selected connection, it is deselected.
 * Otherwise, the selected connection is updated and the UI is updated accordingly.
 * @param {number} id The ID of the connection that was clicked.
 * @param {string} name The name of the connection that was clicked.
 */
const handleCheckboxChange = (id: number, name: string) => {
    // If the selected ID is the same as the one clicked, unselect it
    if (selectedConnection.value === id) {
        selectedConnection.value = null;
        selectedConnectionName.value = '';
        isConnectionSelected.value = false;
    } else {
        selectedConnection.value = id;
        selectedConnectionName.value = name;
        isConnectionSelected.value = true;
    }
}

/**
 * Handles the submission of the form for creating a dataset using the database method.
 * Validates the form, creates a new artifact with the selected protocol and consolidation type,
 * and then submits the data to the server. If the submission is successful, the function resets
 * the form and moves to the next step in the process. If the submission fails, the function shows
 * an error message and remains on the same step.
 */
const handleSubmitDatabase = async () => {
    const form = document.getElementById('dataset-step-2-database-connection') as HTMLFormElement;

    if (props.currentStep === 2 && form) {
        if (!form.checkValidity()) {
            // Report validity and highlight invalid fields
            form.reportValidity();
            highlightInvalidFields(form);
            console.log('Form is invalid, showing error messages or highlighting fields.');
            return;
        }

        // Create FormData object from the form inputs
        const formData = new FormData(form);
        const uuid = generateUUID();

        // Prepare the source data based on form input
        const source_data: any = {
            source_type: formData.get('database-type'),
            host: formData.get('database-host'),
            port: formData.get('database-port'),
            username: formData.get('database-username'),
            password: formData.get('database-password'),
        };

        // Handle database-specific fields
        if (formData.get('database-type') === 'PostgreSQL') {
            source_data.database = formData.get('database-database-name') as string;
            source_data.schema = formData.get('database-schema') as string;
        } else if (formData.get('database-type') === 'Cassandra') {
            source_data.keyspace = formData.get('') as string;
        } else {
            source_data.database = formData.get('database-database-name') as string;
        }

        // Prepare the final data object to be submitted
        const data = {
            name: formData.get('connection-name') as string,
            description: formData.get('connection-description') as string,
            dataset_id: props.createdDatasetId,
            source_data: source_data
        };


        // Show loading state
        updateLoadingUI(true);

        try {
            // Attempt to submit the data using the streaming method
            await props.submitDataStreaming(data);
            console.log('Data submitted successfully Streaming:', data);
            form.reset();
            clearAllValidationErrors(form);
            props.nextStep();
        } catch (error) {
            console.error('Error during data submission:', error);
        } finally {
            updateLoadingUI(false);
        }

    } else {
        props.nextStep();
    }
}

// Expose the handleSubmitDatabase method to the parent component
defineExpose({
    handleSubmitDatabase
});


</script>